<?php
/**
* Template for Team CPT archive page
*
* @package littledino-core\includes\post-types\team
* @author WebGeniusLab <webgeniuslab@gmail.com>
* @since 1.0.0
* @version 1.0.7
*/

use WglAddons\Templates\WglTeam;

$defaults = [
    'posts_per_line' => '3',
    'grid_gap' => '30',
    'hide_title' => '',
    'single_link_heading' => 'yes',
    'hide_soc_icons' => '',
    'hide_department' => '',
    'hide_content' => true,
    'letter_count' => '100',
    'bg_color_type' => 'def',
    'info_align' => 'left',
    'single_link_wrapper' => true,
    'grayscale_anim' => '',
    'info_anim' => '',
    'hide_since' => 'yes',
    // Query
    'post_type' => 'team',
    'number_of_posts' => 'all',
    'order_by' => 'date',
    'order' => 'ASC',
];

extract($defaults);

$style_gap = ($grid_gap != '0') ? ' style="margin-right:-' . esc_attr($grid_gap / 2) . 'px; margin-left:-' . esc_attr($grid_gap / 2) . 'px;"' : '';

$team_classes = ' team-col_' . $posts_per_line;
$team_classes .= ' a' . $info_align;

// Render
get_header();

echo '<div class="wgl-container">',
    '<div id="main-content">',
        '<div class="wgl_module_team', esc_attr($team_classes), '">',
            '<div class="team-items_wrap"', $style_gap, '>',
                (new WglTeam())->render_wgl_team($defaults),
            '</div>',
        '</div>',
    '</div>',
'</div>';

get_footer();
